VERSION 5.00
Begin VB.Form frmMain 
   Appearance      =   0  'Flat
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "ReportEase Plus Demo"
   ClientHeight    =   2520
   ClientLeft      =   1485
   ClientTop       =   3705
   ClientWidth     =   4260
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "DM2_OCX.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2520
   ScaleWidth      =   4260
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdPrintToRTF 
      Caption         =   "Print to RTF"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   372
      Left            =   3240
      TabIndex        =   5
      Top             =   840
      Width           =   972
   End
   Begin VB.CommandButton cmdPreview 
      Caption         =   "Preview"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   372
      Left            =   3240
      TabIndex        =   3
      Top             =   360
      Width           =   972
   End
   Begin VB.CommandButton cmdEdit 
      Caption         =   "Edit"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   372
      Left            =   2160
      TabIndex        =   2
      Top             =   2040
      Width           =   972
   End
   Begin VB.ListBox lstReportForms 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1425
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   3012
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   372
      Left            =   120
      ScaleHeight     =   345
      ScaleWidth      =   465
      TabIndex        =   0
      Top             =   2040
      Visible         =   0   'False
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "Report List:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   252
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   3012
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileViewSaved 
         Caption         =   "&View Saved Report Output"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "&Exit"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Function OpenThisDoc(ByVal FileName As String) As Long
  
Dim lTask As Long
Const SW_SHOWMAXIMIZED = 3

On Error Resume Next
'Note, ShellExecute apparently has a 256 character limit for the FileName.

lTask = ShellExecute(GetDesktopWindow(), "Open", FileName, 0&, 0&, SW_SHOWMAXIMIZED)

OpenThisDoc = lTask
  
End Function
Sub LoadListOfReportForms()
Dim FileName As String
Dim iFile As Integer

FileName = Dir(App.Path & "\*.fpc", 0)
iFile = FreeFile                ' file number

'Note. We look for the free file number, and then use it, close it and repeat the process
'over and over. Maybe we should change the code to get a new freefile each time...

Do While FileName <> ""

   FileName = LCase(FileName) ' Format as lowercase for later display.
   lstReportForms.AddItem FileName

   ' get the next file
   FileName = Dir        ' get the next file

Loop

End Sub




Private Sub cmdEdit_Click()
Dim sFileName As String
Dim iListIndex As Integer
Dim temp As Long

iListIndex = lstReportForms.ListIndex

If iListIndex = -1 Then
  MsgBox "Please select a report form first"
  Exit Sub
End If

sFileName = App.Path & "\" & lstReportForms.List(iListIndex)
FormParm.file = sFileName & Chr(0)  ' specify the file name

Load frmDesign

temp = RvbForm(frmDesign.Rep1.pCtl, FormParm)
If temp <> 0 Then MsgBox "Error calling the Form Editor!"

temp = RepSetFlags(frmDesign.Rep1.hFrWnd, 0, True, RFLAG_ALLOW_DESCEND_SORT Or RFLAG_ALT_NUM_DECIMAL)
frmDesign.Show vbModal

End Sub








Private Sub cmdPreview_Click()
Dim sFileName As String
Dim iListIndex As Integer
Dim temp As Long

iListIndex = lstReportForms.ListIndex

If iListIndex = -1 Then
  MsgBox "Please select a report form first"
  Exit Sub
End If

sFileName = App.Path & "\" & lstReportForms.List(iListIndex)

FrmReportPreview.Show
FrmReportPreview.RunReport sFileName, "S", ""

End Sub

Private Sub cmdPrintToRTF_Click()

Dim sFileName As String
Dim iListIndex As Integer
Dim temp As Long
Dim iChoice As Integer
Dim lTask As Long

iListIndex = lstReportForms.ListIndex

If iListIndex = -1 Then
  MsgBox "Please select a report form first."
  Exit Sub
End If

sFileName = App.Path & "\" & lstReportForms.List(iListIndex)

Load FrmReportPreview
FrmReportPreview.Rep1.standalone = True
FrmReportPreview.RunReport sFileName, "R", App.Path & "\report.rtf"
Unload FrmReportPreview

iChoice = MsgBox("Would you like to view the report RTF file output?", vbYesNoCancel, "View RTF Output File")
If iChoice = vbYes Then
  lTask = OpenThisDoc(App.Path & "\report.rtf")
End If

End Sub


Private Sub Form_Load()
    Dim temp As Integer
    Dim i As Integer

    ' Initialize the form editor input structure
    
    FormParm.open = False ' form editor not yet open
    FormParm.x = 0    ' x position in pixel units
    FormParm.y = 0    ' y position in pixel units

    ' width and height in pixel units
    FormParm.width = Screen.width / Screen.TwipsPerPixelX
    FormParm.height = Screen.height / Screen.TwipsPerPixelY
    FormParm.height = (FormParm.height * 9) / 10

    FormParm.file = Chr(0)              ' no file name yet
    FormParm.DataSetName = "CUSTOMER" + Chr(0) ' data set name

    FormParm.ShowMenu = True            ' show menu bar
    FormParm.ShowHorBar = True          ' show horizontal scroll bar
    FormParm.ShowVerBar = True          ' show vertical scroll bar

    FormParm.hInst = 0
    FormParm.hPrevInst = 0

    FormParm.hFrWnd = 0                 ' RvbForm function fills in the editor window handle
    FormParm.hParentWnd = hWnd          ' Handle of the for which contains the roc control

    FormParm.style = WS_OVERLAPPEDWINDOW ' editor window style

    FormParm.FontTypeFace = Chr(0)      ' use default type face
    
    ' Initialize the report input parameter structure
    RepParm.hInst = 0
    RepParm.hPrevInst = 0
    RepParm.hParentWnd = hWnd           ' window handle for the form which contains the roc control
    RepParm.style = WS_OVERLAPPEDWINDOW ' window style
    RepParm.SwapDir = Chr(0)            ' default swap directory
    RepParm.SuppressPrintMessages = False ' show print messages
    RepParm.UseCurrentPrinter = False ' use the printer specified in the form
    RepParm.OutFile = Chr(0)          ' use default
    
    ' Initialize the report viewer parameter structure
    ViewParm.file = Chr(0)              ' let the API do the file selection
    ViewParm.device = "A"
    ViewParm.x = FormParm.x            ' output window location
    ViewParm.y = FormParm.y
    ViewParm.width = FormParm.width    ' output window width
    ViewParm.height = FormParm.height  ' output window height
    ViewParm.hInst = 0
    ViewParm.hPrevInst = 0
    ViewParm.hParentWnd = hWnd         ' window handle for the form which contains the roc control
    ViewParm.style = WS_OVERLAPPEDWINDOW ' window style
    ViewParm.SwapDir = Chr(0)            ' default swap directory
    ViewParm.SuppressPrintMessages = False ' show print messages

    ' set the demo data file names and read the field names
    DataFile(0).name = "CUSTOMER"
    DataFile(1).name = "SALES"

    For i = 0 To MAX_FILES - 1
      ReadFields (i)
    Next i

    ' load the customer logo bitmap
    Picture1.Picture = LoadPicture(App.Path & "\" & "LOGO.BMP")
    'Picture1.Picture = LoadPicture(App.Path & "\" & "test.jpg")  ' test code

  LoadListOfReportForms
  
End Sub


'  This routine reads the field definition file for the
'  specified file and extracts the individual field names
'  and field properties.
'
Private Sub ReadFields(FileNo As Integer)
   Dim FileName As String
   Dim TextLine As String
   Dim CharReturn As String
   Dim CurLen As Integer
   Dim FieldNo As Integer
   Dim LineIdx As Integer
   Dim FieldType As String
   Dim iFile As Integer
   

   FieldNo = 0
   DataFile(FileNo).TotalFields = 0

   ' open the field definition file
   FileName = App.Path & "\" & DataFile(FileNo).name + ".DF" 'field definition file
   iFile = 1
   Open FileName For Input Access Read As #iFile

READ_LINE:

    ErrorCode = 0
    On Error GoTo ErrorHandler
    Input #iFile, DataField(FileNo, FieldNo).ShortName, DataField(FileNo, FieldNo).width, FieldType, DataField(FileNo, FieldNo).DecPlaces
    On Error GoTo 0
    If ErrorCode Then
       Close iFile
       Exit Sub
    End If

    ' construct other fields
    DataField(FileNo, FieldNo).FullName = DataFile(FileNo).name + "->" + DataField(FileNo, FieldNo).ShortName

    If FieldType = "T" Then DataField(FileNo, FieldNo).type = TYPE_TEXT
    If FieldType = "N" Then DataField(FileNo, FieldNo).type = TYPE_NUM
    If FieldType = "F" Then DataField(FileNo, FieldNo).type = TYPE_DBL
    If FieldType = "D" Then DataField(FileNo, FieldNo).type = TYPE_DATE
    If FieldType = "L" Then DataField(FileNo, FieldNo).type = TYPE_LOGICAL
    If FieldType = "P" Then DataField(FileNo, FieldNo).type = TYPE_PICT

    ' increment the field no
    FieldNo = FieldNo + 1
    DataFile(FileNo).TotalFields = FieldNo

    GoTo READ_LINE

ErrorHandler:
    ErrorCode = Err
    Resume Next

End Sub








Private Sub mnuFileExit_Click()
Unload Me
End Sub


Private Sub mnuFileViewSaved_Click()
 FrmReportViewer.Show vbModal
End Sub




