{******************************************************************************
               Global Constants
*******************************************************************************}
Const
  FORM_SIGN       =$DEBA;

  PDFFLAG_COMPRESS_TEXT  =$1;

  REPFLAG_NO_PICT_PATH  = $1;
  REPFLAG_NO_OVERLAP_MSG = $2;


  GROUP         = $0;
  LABEL_OBJECT  = $10;
  FIELD         = $20;
  SECTION       = $40;
  PICT          = $80;
  LINE          = $100;

  UNITS_PER_INCH  =250;
  NAME_WIDTH      =50;
  MAX_WIDTH       =300;

  SRC_APPL        =0;
  SRC_CALC        =1;
  SRC_SYS         =2;
  SRC_CONST       =3;
  SRC_NONE        =4;
  SRC_DLG         =5;

  TYPE_NUM        =1;
  TYPE_DBL        =2;
  TYPE_TEXT       =3;
  TYPE_LOGICAL    =4;
  TYPE_DATE       =5;
  TYPE_PICT       =6;

  SUM_NONE        =0;
  SUM_TOTAL       =1;
  SUM_AVERAGE     =2;
  SUM_COUNT       =3;
  SUM_MAX         =4;
  SUM_MIN         =5;
  SUM_FTR_TOTAL   =6;       // accumulate when the previous section breaks

  DT_MMDDYY       =0;
  DT_DDMMYY       =1;
  DT_MMDDYYYY     =2;
  DT_MMMDDYYYY    =3;
  DT_YYYYMMDD     = 4;
  DT_DDMMYYYY     = 5;

  FLAG_TRIM       =$1;
  FLAG_SUP_ZERO   =$2;
  FLAG_PAD_ZERO   =$4;
  FLAG_CAPS       =$8;
  FLAG_FIRST_CAP  =$10;
  FLAG_SMALL      =$20;
  FLAG_COMMA      =$40;
  FLAG_WRAP       =$80;
  FLAG_WORD_WRAP  =$100;
  FLAG_RETAIN     =$200;
  FLAG_FLEX_SIZE  =$400;
  FLAG_NULL       =$4000;
  FLAG_AUTOSIZE    =$10000;
  FLAG_KEEP_ASPECT =$20000;
  FLAG_RESERVE_EMPTY_SPACE =$40000;
  FLAG_SORT_DESCEND  = $80000;
  FLAG_DATE_ONLY    = $100000;

  FLAG1_DEF_STYLE    = $1;     
  FLAG1_CALC_DONE    = $2;     
  FLAG1_CURRENCY_AFTER = $4;
  FLAG1_INVISIBLE    = $8;

  RFLAG_TRIAL     =$1;
  RFLAG_ALLOW_DESCEND_SORT = $80;
  RFLAG_ALT_NUM_DECIMAL    = $200;
  RFLAG_CENTER_DLGS_ON_SCR = $400;

  MAX_SECTIONS    =56;
  SEC_HDR_PAGE    =0;
  SEC_HDR_REP1    =1;
  SEC_HDR_REP2    =2;
  SEC_HDR_REP3    =3;
  SEC_HDR_REP4    =4;
  SEC_HDR_REP5    =5;
  SEC_HDR_REP6    =6;
  SEC_HDR_REP7    =7;
  SEC_HDR_REP8    =8;
  SEC_HDR_REP9    =9;
  SEC_HDR_LVL1    =10;
  SEC_HDR_LVL2    =11;
  SEC_HDR_LVL3    =12;
  SEC_HDR_LVL4    =13;
  SEC_HDR_LVL5    =14;
  SEC_HDR_LVL6    =15;
  SEC_HDR_LVL7    =16;
  SEC_HDR_LVL8    =17;
  SEC_HDR_LVL9    =18;
  SEC_DETAIL1     =19;
  SEC_DETAIL2     =20;
  SEC_DETAIL3     =21;
  SEC_DETAIL4     =22;
  SEC_DETAIL5     =23;
  SEC_DETAIL6     =24;
  SEC_DETAIL7     =25;
  SEC_DETAIL8     =26;
  SEC_DETAIL9     =27;
  SEC_DETAIL10    =28;
  SEC_DETAIL11    =29;
  SEC_DETAIL12    =30;
  SEC_DETAIL13    =31;
  SEC_DETAIL14    =32;
  SEC_DETAIL15    =33;
  SEC_DETAIL16    =34;
  SEC_DETAIL17    =35;
  SEC_DETAIL18    =36;
  SEC_FTR_LVL9    =37;
  SEC_FTR_LVL8    =38;
  SEC_FTR_LVL7    =39;
  SEC_FTR_LVL6    =40;
  SEC_FTR_LVL5    =41;
  SEC_FTR_LVL4    =42;
  SEC_FTR_LVL3    =43;
  SEC_FTR_LVL2    =44;
  SEC_FTR_LVL1    =45;
  SEC_FTR_REP1    =46;
  SEC_FTR_REP2    =47;
  SEC_FTR_REP3    =48;
  SEC_FTR_REP4    =49;
  SEC_FTR_REP5    =50;
  SEC_FTR_REP6    =51;
  SEC_FTR_REP7    =52;
  SEC_FTR_REP8    =53;
  SEC_FTR_REP9    =54;
  SEC_FTR_PAGE    =55;

  SFLAG_PAGE_BEF    =$1;
  SFLAG_PAGE_AFT    =$2;
  SFLAG_REPRINT     =$4;
  SFLAG_TRIM_BEFORE =$8;
  SFLAG_TRIM_AFTER  =$10;
  SFLAG_RESET_PAGE_NO =$20;
  SFLAG_KEEP_WITH_NEXT =$40;
  SFLAG_RESET_HEIGHT =$80; 
  SFLAG_KEEP        =$100; 
  SFLAG_VAR_HEIGHT  =$200; 

  OFLAG_FILL    = $2;
  OFLAG_HLEFT   = $4;
  OFLAG_HRIGHT  = $8;
  OFLAG_HCENTER = $10;
  OFLAG_VTOP    = $20;
  OFLAG_VCENTER = $40;
  OFLAG_VBOTTOM = $80;
  OFLAG_SELECT_TOGGLE = $100;
  OFLAG_MULTILINE = $200;
  OFLAG_VERT    = $400;
  OFLAG_INVISIBLE = $800;
  OFLAG_DEF_STYLE = $1000;  
  OFLAG_MARKED    = $2000;  
  OFLAG_HLINK     = $4000;
  OFLAG_CUR_ITEM  = $8000;  

  OUTLINE_LEFT  = $1;
  OUTLINE_RIGHT = $2;
  OUTLINE_TOP   = $4;
  OUTLINE_BOT   = $8;

  ERR_NO_FILE     =1;
  ERR_NO_DEVICE   =2;
  ERR_NO_MEM      =3;
  ERR_BAD_EXP     =4;
  ERR_SUSPEND     =5;
  ERR_ZERO_DIVIDE =6;
  ERR_TYPE_MISMATCH =7;
  ERR_INCOMPLETE  =8;
  ERR_DUPLICATE   =9;
  ERR_PRINTER     =10;
  ERR_IO          =11;
  ERR_DISPLAY     =12;
  ERR_WRAP        =13;
  ERR_FONT        =14;
  ERR_OTHER       =15;

  ERR_BAD_WND     =16;
  ERR_NO_REP_ID   =17;
  ERR_BAD_REP_ID  =18;
  ERR_NO_OUTFILE  =19;

  REP_CLOSE       =WM_USER;

  REP_SAVE_AS     =WM_USER+1;
  REP_UPDATE_TOOLBAR =WM_USER+1300;
  REP_PREPROESS      =WM_USER+1301;
  REP_POSTPROESS     =WM_USER+1302;
  REP_FIELD_DROP     =WM_USER+1303;

  ACTION_COMMAND      = 1;
  ACTION_VSCROLL      = 2;
  ACTION_HSCROLL      = 3;
  ACTION_LBUTTONDOWN  = 5;
  ACTION_RBUTTONDOWN  = 6;
  ACTION_LBUTTONUP    = 7;
  ACTION_RBUTTONUP    = 8;
  ACTION_LBUTTONDBLCLK = 9;
  ACTION_RBUTTONDBLCLK = 10;
  ACTION_SIZE         = 11;
  ACTION_SETFOCUS     = 12;
  ACTION_KILLFOCUS    = 13;
  ACTION_MOUSEMOVE    = 14;

  FILE_RTF       = 1;
  FILE_HTML      = 2;
  FILE_TXT       = 3;
  FILE_NATIVE    = 4;

  REP_BOLD              =$1;
  REP_ULINE             =$2;
  REP_ITALIC            =$4;
  REP_STRIKE            =$8;

{ *****************************************************************************
                    Command Ids
  ******************************************************************************}
    ID_FIRST             =600;
    ID_PGUP              =600;
    ID_PGDN              =601;
    ID_UP                =602;
    ID_DOWN              =603;
    ID_LEFT              =604;
    ID_RIGHT             =605;
    ID_INSERT_LABEL      =606;
    ID_REN_FONT_EXP      =607;
    ID_MOVE_ITEM         =608;
    ID_SIZE_ITEM         =609;
    ID_CENTER_ITEM       =610;
    ID_SELECT_MULTIPLE   =611;
    ID_EDIT_LABEL        =612;

    ID_PRINT             =613;
    ID_PREVIEW           =614;
    ID_EXIT              =615;

    ID_REN_CALC_FLD      =616;


    ID_ADD_FONT_EXP      =617;
    ID_MOD_FONT_EXP      =618;
    ID_DEL_FONT_EXP      =619;


    ID_PICT_FROM_CB      =620;
    ID_PICT_FROM_FILE    =621;
    ID_HELP              =622;
    ID_JUMP              =623;
    ID_SAVE              =624;
    ID_SAVEAS            =625;
    ID_QUIT              =626;
    ID_REP_PARAM         =628;
    ID_REP_FILTER        =629;
    ID_PRINT_OPTIONS     =630;

    ID_ITEM_FONT_EXP     =631;
    ID_DEF_STYLE_ITEM    =632;
    ID_DEF_STYLE_FIELD   =633;
    ID_APPLY_DEF_ITEM_STYLE =634;
    ID_APPLY_DEF_FIELD_STYLE =635;
    ID_SEC_DEL           =636;

    ID_ERASE_CB          =637;

    ID_FONTS             =638;

    ID_EDIT_FLD          =639;
    ID_EDIT_FLD_EXP      =640;

    ID_INSERT_DATA       =641;
    ID_INSERT_CALC       =642;
    ID_INSERT_SYS        =643;
    ID_INSERT_DLG        =644;

    ID_SEC_NEW           =645;
    ID_SEC_EDIT          =646;

    ID_SEC_FILTER        =648;
    ID_SEC_SORT          =649;
    ID_SEC_BREAK         =650;

    ID_DLG_CREATE        =651;
    ID_DLG_MODIFY        =652;
    ID_DLG_DELETE        =653;

    ID_PAGE_TOP          =654;
    ID_PAGE_BOT          =655;

    ID_SHOW_BOUNDERS     =656;
    ID_SHOW_FIELD_NAMES  =657;
    ID_LCASE_FIELD_NAMES =658;
    ID_SPELL             =659;

    ID_INSERT_LINE       =660;
    ID_ITEM_OUTLINE      =661;
    ID_ITEM_BACKGROUND   =662;
    ID_POS_ITEM          =663;
    ID_DEL_ITEM          =664;
    ID_UNDO              =665;
    ID_EDIT_LINE         =666;

    ID_NEXT_PAGE         =667;
    ID_PREV_PAGE         =668;
    ID_FIRST_PAGE        =669;
    ID_LAST_PAGE         =670;

    ID_EDIT_LABEL_FMT    =671;

    ID_ADD_FONT_NAME     =672;
    ID_MOD_FONT_NAME     =673;
    ID_DEL_FONT_NAME     =674;

    ID_ALIGN_HORZ_TOP    =675;
    ID_ALIGN_HORZ_BOT    =676;
    ID_ALIGN_HORZ_CENTER =677;
    ID_ALIGN_VERT_LEFT   =678;
    ID_ALIGN_VERT_RIGHT  =679;
    ID_ALIGN_VERT_CENTER =680;

    ID_EVEN_SIZE_HORZ    =681;
    ID_EVEN_SIZE_VERT    =682;

    ID_EVEN_SPACE_HORZ   =683;
    ID_EVEN_SPACE_VERT   =684;

    ID_DESC_WND          =685;
    ID_CUT               =686;
    ID_COPY              =687;
    ID_PASTE             =688;
    ID_SNAP_TO_GRID      =689;

    ID_EXPAND_HORZ       =690;
    ID_EXPAND_VERT       =691;
    ID_COMPRESS_HORZ     =692;
    ID_COMPRESS_VERT     =693;

    ID_BOLD_ON           =694;
    ID_ULINE_ON          =695;
    ID_ITALIC_ON         =696;
    ID_CENTER            =697;
    ID_RIGHT_JUSTIFY     =698;
    ID_JUSTIFY           =699;
    ID_LEFT_JUSTIFY      =700;
    ID_INSERT_DATE_TIME  =701;
    ID_INSERT_PAGE_NUMBER =702;
    ID_INSERT_PAGE_COUNT =703;

    ID_NEW               =704;
    ID_OPEN              =705;
    ID_TOP_JUSTIFY       =706;
    ID_BOT_JUSTIFY       =707;
    ID_TEXT_COLOR        =708;
    ID_FILL_COLOR        =709;
    ID_BORDER_COLOR      =710;

type

{*****************************************************************************
                        Field Structure
*****************************************************************************}

   StrField = record
         source: Integer;              { source of field data: application,calculation,system, constant etc }

         reserved3: array [0..NAME_WIDTH+1] of char; { reserved }
         FileId: Integer;              { an optional id that may be defined by the calling application }
         FieldId: Integer;             { another optional id that may be defined by the calling application}
         Fieldtype: Integer;           { numeric/alphanumeric/logical/date }
         width: Integer;               { field data width as stored in your database}
         DecPlaces: Integer;           { decimal places for numeric fields }
         AllowChanges: Integer;        { Allow modification of the following fields }

         InUse: Integer;               { TRUE=in use, FALSE=not in use }
         flags: Integer;               { flags }
         SumType: Integer;             { summary type: total/average/minmum/maximum/none }
         SysIdx: Integer;              { index into the system field table for system fields }

         DateFormat: Integer;          { date format }
         DateDelim: array [0..1] of char;  { date delimiter character, i.e. / or - }

         CurrencySymbol: array [0..3] of char;  { currency symbol }
         LogicalSymbols: array [0..1] of char;  { logical TRUE and FALSE symbols }

         NegSignPrefix: array [0..3] of char;   { negative sign prefix }
         NegSignSuffix: array [0..3] of char;   { negative sign suffix }
         PosSignPrefix: array [0..3] of char;   { positive sign prefix }
         PosSignSuffix: array [0..3] of char;   { positive sign suffix }

         CalcExp: array [0..NAME_WIDTH+1] of integer; { expression for the calculated fields }

         CharData: pChar;              { character data, pointer to an object of size = field.width+1 }
         NumData: LongInt;             { numeric data (long) }
         DblData: double;              { numeric data for field = TYPE_DBL }

         HoldNum: LongInt;             { long accumulater: total,minimum,maximum,etc...}
         HoldDbl: double;              { double accumulater: total,minimum,maximum,etc...}
         count: LongInt;               { number of records in a group during execution }

         section: Integer;             { section that holds the field (report time only)}
         misc: Integer;                { used for miscellaneous purposes }

         ParaChar: array [0..1] of char; { specify the new paragraph indicator character
                                           in the first byte.  Needed only for a word/wrapped
                                           text field. }

         reserved: array [0..9] of char;
         flags1: LongInt;              {FLAG1_ constant}
         
         name: array [0..2*NAME_WIDTH+1] of char; { field name }
       end;


   AStrField = array [0..0] of StrField;  { pointer to the field structure }
   PStrField = ^AStrField;

{*****************************************************************************
   The parameter structure definition that is used by your application
   to specify the operation parameters and text data to the 'form' routine.
   For an example for using this structure, refer to the demo.c file.
*****************************************************************************}

   StrForm = record
       x: Integer;       { Initial x position of the editing window,
                           you may specify CW_USEDEFAULT to use default values.}
       y: Integer;       { Initial y position of the editing window.}
       width : Integer;  { Initial width of the window in device units,
                           you may specify CW_USEDEFAULT to use default values.}
       height : Integer; { Initial height of the editing window.  When you
                           use CW_USEDEFAULT for width, the height parameter is
                           ingnored.}

       UserSelection: Pointer;
                           { Arguments: (hWnd: Handle; fields : StrField; SortLevel: int)

                             A pointer to the function returning the user
                           selected field through the structure pointer.
                           Your application returns the chosen field through
                           the second parameter.  The third argument indicates
                           the sort field number. If it is equal to zero,
                           it means that the field being sought is not a sort
                           field. The function returns a TRUE value if
                           successful.

                           When using ReportEase as a DLL, this pointer must
                           be passed using the MakeProcInstance function.  Your
                           application must define this function as exportatable
                           and include it it the EXPORT section of the
                           definition file.
                           }

       VerifyField: Pointer;
                           { Arguments: (fields:  StrField; SortLevel: integer)
                             A pointer to the user routine that validate a
                           field name.  The field name is passed to the routine
                           by the 'name' variable in the StrField structure.
                           This routine should also fill the 'type' variable
                           in the structure. The second arguement indicates the
                           sort field number. If it is equal to zero, it means
                           that the field to verify is not a sort field.  The
                           function returns TRUE to indicate a valid field.

                           When using ReportEase as a DLL, this pointer must
                           be passed using the MakeProcInstance function.  Your
                           application must define this function as exportatable
                           and include it it the EXPORT section of the
                           definition file
                           }


       FileName: array [0..299] of char;  { form file name. If an existing file is specified,
                           the following fields are ignored.}

       DataSetName: array [0..19] of char ;{ (Specify for a new file) Your application can
                           specify a data set name which can be used to
                           associate the application data to the form.  This
                           is an optional field. }

        ShowMenu: LongBool;  { show the menu bar ? }
        ShowHorBar: LongBool;{ show the horizonatal scroll bar }
        ShowVerBar: LongBool;{ show the vertical scroll bar }

        hInst: THandle;    {  Handle of the current instanaces. }
        hPrevInst: THandle;{  Handle of the previous instances. }
        hParentWnd: THandle;{ Handle to the parent window }
        hFrWnd: THandle;   {  Form main window handle, will be filled by RE later  }
        style: LongInt;    {  Editor window style }
        FontTypeFace: array [0..31] of char; { Default type face, example: TmwRmn Courier, etc }
        open: LongBool;    { TRUE indicates an open window (parameter block in use)}
        modified: LongBool;{ TRUE when the file modified, and needs to be saved }

        ShowToolbar: LongBool; {character picture for text output. Use 0 for default.}
   
        MasterDefFile: array [0..299] of char;  // Master definition file
        DetailDefFile: array [0..299] of char;  // detail definition file
        OtherDefFiles: array [0..1199] of char;  // other definition files (list .df file names list delimted by comma)

        DataMapPictFile: array [0..299] of char; // jpeg file which visually shows the data file relationships

        end;


{****************************************************************************
   The parameter structure definition that is used by your application
   to specify the operation parameters to start a report execution session.
   For an example for using this structure, refer to the demo.c file.
****************************************************************************}

   StrRep = record
       FileName: array [0..299] of char;   { form file name}

       device: char;      { P=Printer,S=Screen, F=Native Format File,
                            R=Rtf Format File, H=Html File, T=Text file,
                            C=Comma delimited text file, B=tab delimted text file
                            D=PDF format file (must install WinPDF Converter), A=Ask the user.
                            The following 4 parameters are not used if the
                            device is set to 'P', 'F' ,'R', 'H', 'T', 'D', or 'C'.  }

       pad: array [0..2] of char;  // 3 bytes padding so that the next integer variable is 4 byte aligned

       x: Integer;         { Initial x position of the report window,
                             you may specify CW_USEDEFAULT to use default values.}
       y: Integer;         { Initial y position of the report window.}
       width: Integer;     { Initial width of the window in device units,
                             you may specify CW_USEDEFAULT to use default values.}
       height: Integer;    { Initial height of the editing window.  When you
                             use CW_USEDEFAULT for width, the height parameter is
                             ingnored.}

       field: PStrField;    { (OUTPUT) pointer to an array of fields used by the
                             form.}
       TotalFields: Integer;{ (OUTPUT) Number of fields in the 'field' array. }

       SortField: PStrField; { (OUTPUT) pointer to an array of fields used for
                             sorting.}
       TotalSortFields: Integer; { (OUTPUT) Number of fields in the 'SortField' array. }

       DataSetName: array [0..19] of char;{ (OUTPUT) This field returns the
                              data set name associated with the form.  Your
                              application may use this information to prepare
                              data for the report executer }

       SwapDir: array [0..299] of char;
                             { Directory path to store swapped screen pages
                               When this variable is equal to NULL, RE will use
                               the current working directory for swapping.}

       hInst: THandle;       {  Handle of the current instanaces. }
       hPrevInst: THandle;   {  Handle of the previous instances. }
       hParentWnd: THandle;  {  Handle to the parent window }
       style: LongInt;       {  Report window style - needed for screen output only }

       DrawPicture: Pointer; { Arguments: (hDC: HDC; PictId, FileId, FieldId: integer; rect: TRect; ReportId: Integer);
                             { Pointer to the user routine responsible for
                               drawing 'dynamic picture fields'}
       SuppressPrintMessages: LongBool;  {TRUE to suppress print time messages}
       UseCurrentPrinter: LongBool;  {TRUE to use current printer instead of one from the form}
       ReportId: Integer;     { (OUTPUT) report id assigned by the RepInit function }

       OutFile: array [0..299] of char; { Output file name. This field should
                                  specify a output file name when the device
                                  variable is set to 'F'.  If a file name
                                  is not specified, then this field should
                                  have a 0 in the first character position.}
       TextPitch: Integer;    {character picture for text output. Use 0 for default}
       ShowMenu: LongBool;        {show menu bar.}
       ShowToolbar: LongBool; {character picture for text output. Use 0 for default.}
       DoPreprocessPass: LongBool; {a preprocess pass required for this report}

       MasterDefFile: array [0..299] of char;  // Master definition file
       DetailDefFile: array [0..299] of char;  // detail definition file
       OtherDefFiles: array [0..1199] of char;  // other definition files (list .df file names list delimted by comma)

       MasterDataFile: array [0..299] of char;  // Master record file
       DetailDataFile: array [0..299] of char;  // detail record file
       OtherDataFiles: array [0..1199] of char;  // other data files (list .db file names list delimted by comma)

       PictureNameFile: array [0..299] of char;  // text file containing picture ids and names

       AutoRun: LongBool;        // run automatically using the data files specified in the structure

   end;

{****************************************************************************
   The parameter structure definition that is used by your application
   to specify the operation parameters to view a report file.
   For an example for using this structure, refer to the demo program.
****************************************************************************}

   StrView = record
       FileName: array [0..299] of char;   { report file name}

       device: char;       { P=Printer,S=Screen, A=Ask the user.
                             The following 4 parameters are not used if
                             the device is set to 'P' }
       pad: array [0..2] of char;  // 3 bytes padding so that the next integer variable is 4 byte aligned

       x: Integer;         { Initial x position of the report window,
                             you may specify CW_USEDEFAULT to use default values.}
       y: Integer;         { Initial y position of the report window.}
       width: Integer;     { Initial width of the window in device units,
                             you may specify CW_USEDEFAULT to use default values.}
       height: Integer;    { Initial height of the editing window.  When you
                             use CW_USEDEFAULT for width, the height parameter is
                             ingnored.}

       SwapDir: array [0..299] of char;
                             { Directory path to store swapped screen pages
                               When this variable is equal to NULL, RE will use
                               the current working directory for swapping.}

       hInst: THandle;       {  Handle of the current instanaces. }
       hPrevInst: THandle;   {  Handle of the previous instances. }
       hParentWnd: THandle;  {  Handle to the parent window }
       style: LongInt;       {  Report window style - needed for screen output only }

       SuppressPrintMessages: LongBool;  {TRUE to suppress print time messages}
       ReportId: Integer;     { (OUTPUT) report id assigned by the RepInit function }
       TextPitch: Integer;    {character picture for text output. Use 0 for default}
       ShowToolbar: LongBool; {character picture for text output. Use 0 for default.}

   end;

{*****************************************************************************
                        Form Header Structure
*****************************************************************************}
   StrFormHdr = record
           FormSign: LongInt;          { Form File Signature}

           name: array [0..NAME_WIDTH+1] of char; { report name}

           DataSetName: array [0..19] of char;  { Your application can specify a data set
                                       name which can be used to associate the
                                       application data to the form.  This
                                       is an optional information. }

           TotalItems: Integer;      { screen items in the form template }
           FieldCount: Integer;      { total number of fields }
           BreakFieldCount: Integer; { total number of break fields }
           FontCount: Integer;       { number of entries in the font table }

           LeftMargin: Single;       { margins in inches}
           RightMargin: Single;
           TopMargin: Single;
           BottomMargin: Single;

           SelExp: array [0..NAME_WIDTH+1] of integer; { record selection expression }

           Orientation: Integer;     { DMORIENT_PORTRAIT or DMORIENT_LANDSCAPE }
           PaperSize: Integer;       { paper size given by DMPAPER_* variables used for DEVMODE }
           PaperLength: Integer;     { specified in tenths of millimeter, used only if PaperSize = 0 }
           PaperWidth: Integer;      { specified in tenths of millimeter, used only if PaperSize = 0 }
           PrintQuality: Integer;    { print quality }

           OldPrinterName: array [0..NAME_WIDTH+1] of char;      { not used any longer }
           OldPrinterDriver: array [0..NAME_WIDTH+1] of char;    { not used any longer }

           flags: Integer;           { RFLAG_ series flags }

           DateFormat: Integer;      { 0=MM/DD/YY, 1=DD/MM/YY }

           RulerType: Integer;        { RULER_OFF,RULER_INCH,RULER_CM}

           SecBannerHeight: Integer;  { height (logical units) of the section banner}
           FileFormatId: Integer;     { records the file format changes}
           PrinterName: array [0..MAX_WIDTH+1] of char;      { name of the printer }
           PrinterDriver: array [0..MAX_WIDTH+1] of char;    { printer driver name }
           reserved: array [0..145] of char;
       end;

